diff --git a/include/net-snmp/data_access/ipstats.h b/include/net-snmp/data_access/ipstats.h
index 0e7aa1e..0e1bc21 100644
--- a/include/net-snmp/data_access/ipstats.h
+++ b/include/net-snmp/data_access/ipstats.h
@@ -10,6 +10,40 @@
 extern          "C" {
 #endif
 
+#define IPSYSTEMSTATSTABLE_HCINRECEIVES       1
+#define IPSYSTEMSTATSTABLE_HCINOCTETS         2
+#define IPSYSTEMSTATSTABLE_INHDRERRORS        3
+#define IPSYSTEMSTATSTABLE_HCINNOROUTES       4 
+#define IPSYSTEMSTATSTABLE_INADDRERRORS       5
+#define IPSYSTEMSTATSTABLE_INUNKNOWNPROTOS    6
+#define IPSYSTEMSTATSTABLE_INTRUNCATEDPKTS    7
+#define IPSYSTEMSTATSTABLE_HCINFORWDATAGRAMS  8 
+#define IPSYSTEMSTATSTABLE_REASMREQDS         9
+#define IPSYSTEMSTATSTABLE_REASMOKS           10
+#define IPSYSTEMSTATSTABLE_REASMFAILS         11
+#define IPSYSTEMSTATSTABLE_INDISCARDS         12
+#define IPSYSTEMSTATSTABLE_HCINDELIVERS       13
+#define IPSYSTEMSTATSTABLE_HCOUTREQUESTS      14
+#define IPSYSTEMSTATSTABLE_HCOUTNOROUTES      15
+#define IPSYSTEMSTATSTABLE_HCOUTFORWDATAGRAMS 16
+#define IPSYSTEMSTATSTABLE_HCOUTDISCARDS      17
+#define IPSYSTEMSTATSTABLE_HCOUTFRAGREQDS     18
+#define IPSYSTEMSTATSTABLE_HCOUTFRAGOKS       19
+#define IPSYSTEMSTATSTABLE_HCOUTFRAGFAILS     20
+#define IPSYSTEMSTATSTABLE_HCOUTFRAGCREATES   21
+#define IPSYSTEMSTATSTABLE_HCOUTTRANSMITS     22
+#define IPSYSTEMSTATSTABLE_HCOUTOCTETS        23
+#define IPSYSTEMSTATSTABLE_HCINMCASTPKTS      24
+#define IPSYSTEMSTATSTABLE_HCINMCASTOCTETS    25
+#define IPSYSTEMSTATSTABLE_HCOUTMCASTPKTS     26
+#define IPSYSTEMSTATSTABLE_HCOUTMCASTOCTETS   27
+#define IPSYSTEMSTATSTABLE_HCINBCASTPKTS      28
+#define IPSYSTEMSTATSTABLE_HCOUTBCASTPKTS     29
+#define IPSYSTEMSTATSTABLE_DISCONTINUITYTIME  30
+#define IPSYSTEMSTATSTABLE_REFRESHRATE        31
+    
+#define IPSYSTEMSTATSTABLE_LAST IPSYSTEMSTATSTABLE_REFRESHRATE
+    
 /**---------------------------------------------------------------------*/
 /*
  * structure definitions
@@ -20,28 +54,42 @@ extern          "C" {
  */
 typedef struct netsnmp_ipstats_s {
 
+   /* Columns of ipStatsTable. Some of them are HC for computation of the 
+    * other columns, when underlying OS does not provide them.
+    * Always fill at least 32 bits, the table is periodically polled -> 32 bit
+    * overflow shall be detected and 64 bit value should be computed automatically. */
    U64             HCInReceives;
    U64             HCInOctets;
    u_long          InHdrErrors;
-   u_long          InNoRoutes;
+   U64             HCInNoRoutes; 
    u_long          InAddrErrors;
    u_long          InUnknownProtos;
    u_long          InTruncatedPkts;
-   U64             HCInForwDatagrams;
+   
+   /* optional, can be computed from HCInNoRoutes and HCOutForwDatagrams */
+   U64             HCInForwDatagrams; 
+   
    u_long          ReasmReqds;
    u_long          ReasmOKs;
    u_long          ReasmFails;
    u_long          InDiscards;
    U64             HCInDelivers;
    U64             HCOutRequests;
-   u_long          OutNoRoutes;
+   U64             HCOutNoRoutes;
    U64             HCOutForwDatagrams;
-   u_long          OutDiscards;
-   u_long          OutFragReqds;
-   u_long          OutFragOKs;
-   u_long          OutFragFails;
-   u_long          OutFragCreates;
+   U64             HCOutDiscards;
+   
+   /* optional, can be computed from HCOutFragOKs + HCOutFragFails*/
+   U64             HCOutFragReqds;
+   U64             HCOutFragOKs;
+   U64             HCOutFragFails;
+   U64             HCOutFragCreates;
+   
+   /* optional, can be computed from 
+    * HCOutRequests +HCOutForwDatagrams + HCOutFragCreates
+    * - HCOutFragReqds - HCOutNoRoutes  - HCOutDiscards */
    U64             HCOutTransmits;
+   
    U64             HCOutOctets;
    U64             HCInMcastPkts;
    U64             HCInMcastOctets;
@@ -50,6 +98,8 @@ typedef struct netsnmp_ipstats_s {
    U64             HCInBcastPkts;
    U64             HCOutBcastPkts;
 
+   /* Array of available columns.*/
+   int             columnAvail[IPSYSTEMSTATSTABLE_LAST+1];
 } netsnmp_ipstats;
 
 
diff --git a/include/net-snmp/data_access/systemstats.h b/include/net-snmp/data_access/systemstats.h
index 53dfd51..47e1076 100644
--- a/include/net-snmp/data_access/systemstats.h
+++ b/include/net-snmp/data_access/systemstats.h
@@ -22,7 +22,11 @@ extern          "C" {
 typedef struct netsnmp_systemstats_s {
 
    netsnmp_index oid_index;   /* MUST BE FIRST!! for container use */
-   oid           ns_ip_version;
+   /* 
+    * Index of the table
+    * First entry = ip version
+    * Second entry = interface index (0 for ipSystemStatsTable */
+   oid           index[2];           
 
    int       flags; /* for net-snmp use */
 
@@ -49,13 +53,15 @@ netsnmp_container * netsnmp_access_systemstats_container_init(u_int init_flags);
 #define NETSNMP_ACCESS_SYSTEMSTATS_INIT_NOFLAGS               0x0000
 #define NETSNMP_ACCESS_SYSTEMSTATS_INIT_ADDL_IDX_BY_ADDR      0x0001
 
-/*
- * load and free
+/**
+ * Load container. If the NETSNMP_ACCESS_SYSTEMSTATS_LOAD_IFTABLE is set
+ * the ipIfSystemStats table is loaded, else ipSystemStatsTable is loaded.
  */
 netsnmp_container*
 netsnmp_access_systemstats_container_load(netsnmp_container* container,
                                     u_int load_flags);
 #define NETSNMP_ACCESS_SYSTEMSTATS_LOAD_NOFLAGS               0x0000
+#define NETSNMP_ACCESS_SYSTEMSTATS_LOAD_IFTABLE               0x0001 
 
 void netsnmp_access_systemstats_container_free(netsnmp_container *container,
                                          u_int free_flags);
@@ -68,7 +74,7 @@ void netsnmp_access_systemstats_container_free(netsnmp_container *container,
  * create/free an entry
  */
 netsnmp_systemstats_entry *
-netsnmp_access_systemstats_entry_create(int version);
+netsnmp_access_systemstats_entry_create(int version, int if_index);
 
 void netsnmp_access_systemstats_entry_free(netsnmp_systemstats_entry * entry);
 
-- 
1.6.0.2

